// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/HeadingChangeIndication.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/heading_change_indication__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `direction`
#include "etsi_its_vam_ts_msgs/msg/detail/turning_direction__functions.h"
// Member `action_delta_time`
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_tenth_of_second__functions.h"

bool
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__init(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * msg)
{
  if (!msg) {
    return false;
  }
  // direction
  if (!etsi_its_vam_ts_msgs__msg__TurningDirection__init(&msg->direction)) {
    etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__fini(msg);
    return false;
  }
  // action_delta_time
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__init(&msg->action_delta_time)) {
    etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__fini(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * msg)
{
  if (!msg) {
    return;
  }
  // direction
  etsi_its_vam_ts_msgs__msg__TurningDirection__fini(&msg->direction);
  // action_delta_time
  etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__fini(&msg->action_delta_time);
}

bool
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__are_equal(const etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * lhs, const etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // direction
  if (!etsi_its_vam_ts_msgs__msg__TurningDirection__are_equal(
      &(lhs->direction), &(rhs->direction)))
  {
    return false;
  }
  // action_delta_time
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__are_equal(
      &(lhs->action_delta_time), &(rhs->action_delta_time)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__copy(
  const etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * input,
  etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * output)
{
  if (!input || !output) {
    return false;
  }
  // direction
  if (!etsi_its_vam_ts_msgs__msg__TurningDirection__copy(
      &(input->direction), &(output->direction)))
  {
    return false;
  }
  // action_delta_time
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__copy(
      &(input->action_delta_time), &(output->action_delta_time)))
  {
    return false;
  }
  return true;
}

etsi_its_vam_ts_msgs__msg__HeadingChangeIndication *
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * msg = (etsi_its_vam_ts_msgs__msg__HeadingChangeIndication *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication));
  bool success = etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__destroy(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence__init(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__HeadingChangeIndication *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence__fini(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence *
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence * array = (etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence__destroy(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence * input,
  etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__HeadingChangeIndication);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__HeadingChangeIndication * data =
      (etsi_its_vam_ts_msgs__msg__HeadingChangeIndication *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
