// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/HeadingChangeIndication.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__HEADING_CHANGE_INDICATION__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__HEADING_CHANGE_INDICATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/heading_change_indication__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'direction'
#include "etsi_its_vam_ts_msgs/msg/detail/turning_direction__traits.hpp"
// Member 'action_delta_time'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_tenth_of_second__traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const HeadingChangeIndication & msg,
  std::ostream & out)
{
  out << "{";
  // member: direction
  {
    out << "direction: ";
    to_flow_style_yaml(msg.direction, out);
    out << ", ";
  }

  // member: action_delta_time
  {
    out << "action_delta_time: ";
    to_flow_style_yaml(msg.action_delta_time, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const HeadingChangeIndication & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "direction:\n";
    to_block_style_yaml(msg.direction, out, indentation + 2);
  }

  // member: action_delta_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "action_delta_time:\n";
    to_block_style_yaml(msg.action_delta_time, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const HeadingChangeIndication & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::HeadingChangeIndication & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::HeadingChangeIndication & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::HeadingChangeIndication>()
{
  return "etsi_its_vam_ts_msgs::msg::HeadingChangeIndication";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::HeadingChangeIndication>()
{
  return "etsi_its_vam_ts_msgs/msg/HeadingChangeIndication";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::HeadingChangeIndication>
  : std::integral_constant<bool, has_fixed_size<etsi_its_vam_ts_msgs::msg::DeltaTimeTenthOfSecond>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::TurningDirection>::value> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::HeadingChangeIndication>
  : std::integral_constant<bool, has_bounded_size<etsi_its_vam_ts_msgs::msg::DeltaTimeTenthOfSecond>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::TurningDirection>::value> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::HeadingChangeIndication>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__HEADING_CHANGE_INDICATION__TRAITS_HPP_
