// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruLowFrequencyContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_LOW_FREQUENCY_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_LOW_FREQUENCY_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'profile_and_subprofile'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_profile_and_subprofile__struct.hpp"
// Member 'size_class'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_size_class__struct.hpp"
// Member 'exterior_lights'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_exterior_lights__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VruLowFrequencyContainer_
{
  using Type = VruLowFrequencyContainer_<ContainerAllocator>;

  explicit VruLowFrequencyContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : profile_and_subprofile(_init),
    size_class(_init),
    exterior_lights(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->size_class_is_present = false;
      this->exterior_lights_is_present = false;
    }
  }

  explicit VruLowFrequencyContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : profile_and_subprofile(_alloc, _init),
    size_class(_alloc, _init),
    exterior_lights(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->size_class_is_present = false;
      this->exterior_lights_is_present = false;
    }
  }

  // field types and members
  using _profile_and_subprofile_type =
    etsi_its_vam_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator>;
  _profile_and_subprofile_type profile_and_subprofile;
  using _size_class_type =
    etsi_its_vam_ts_msgs::msg::VruSizeClass_<ContainerAllocator>;
  _size_class_type size_class;
  using _size_class_is_present_type =
    bool;
  _size_class_is_present_type size_class_is_present;
  using _exterior_lights_type =
    etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator>;
  _exterior_lights_type exterior_lights;
  using _exterior_lights_is_present_type =
    bool;
  _exterior_lights_is_present_type exterior_lights_is_present;

  // setters for named parameter idiom
  Type & set__profile_and_subprofile(
    const etsi_its_vam_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator> & _arg)
  {
    this->profile_and_subprofile = _arg;
    return *this;
  }
  Type & set__size_class(
    const etsi_its_vam_ts_msgs::msg::VruSizeClass_<ContainerAllocator> & _arg)
  {
    this->size_class = _arg;
    return *this;
  }
  Type & set__size_class_is_present(
    const bool & _arg)
  {
    this->size_class_is_present = _arg;
    return *this;
  }
  Type & set__exterior_lights(
    const etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator> & _arg)
  {
    this->exterior_lights = _arg;
    return *this;
  }
  Type & set__exterior_lights_is_present(
    const bool & _arg)
  {
    this->exterior_lights_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VruLowFrequencyContainer_ & other) const
  {
    if (this->profile_and_subprofile != other.profile_and_subprofile) {
      return false;
    }
    if (this->size_class != other.size_class) {
      return false;
    }
    if (this->size_class_is_present != other.size_class_is_present) {
      return false;
    }
    if (this->exterior_lights != other.exterior_lights) {
      return false;
    }
    if (this->exterior_lights_is_present != other.exterior_lights_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const VruLowFrequencyContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VruLowFrequencyContainer_

// alias to use template instance with default allocator
using VruLowFrequencyContainer =
  etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_LOW_FREQUENCY_CONTAINER__STRUCT_HPP_
