// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruMotionPredictionContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_MOTION_PREDICTION_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_MOTION_PREDICTION_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/vru_motion_prediction_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'path_history'
#include "etsi_its_vam_ts_msgs/msg/detail/path_history__traits.hpp"
// Member 'path_prediction'
#include "etsi_its_vam_ts_msgs/msg/detail/path_predicted__traits.hpp"
// Member 'safe_distance'
#include "etsi_its_vam_ts_msgs/msg/detail/sequence_of_safe_distance_indication__traits.hpp"
// Member 'trajectory_interception_indication'
#include "etsi_its_vam_ts_msgs/msg/detail/sequence_of_trajectory_interception_indication__traits.hpp"
// Member 'acceleration_change_indication'
#include "etsi_its_vam_ts_msgs/msg/detail/acceleration_change_indication__traits.hpp"
// Member 'heading_change_indication'
#include "etsi_its_vam_ts_msgs/msg/detail/heading_change_indication__traits.hpp"
// Member 'stability_change_indication'
#include "etsi_its_vam_ts_msgs/msg/detail/stability_change_indication__traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VruMotionPredictionContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: path_history
  {
    out << "path_history: ";
    to_flow_style_yaml(msg.path_history, out);
    out << ", ";
  }

  // member: path_history_is_present
  {
    out << "path_history_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.path_history_is_present, out);
    out << ", ";
  }

  // member: path_prediction
  {
    out << "path_prediction: ";
    to_flow_style_yaml(msg.path_prediction, out);
    out << ", ";
  }

  // member: path_prediction_is_present
  {
    out << "path_prediction_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.path_prediction_is_present, out);
    out << ", ";
  }

  // member: safe_distance
  {
    out << "safe_distance: ";
    to_flow_style_yaml(msg.safe_distance, out);
    out << ", ";
  }

  // member: safe_distance_is_present
  {
    out << "safe_distance_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.safe_distance_is_present, out);
    out << ", ";
  }

  // member: trajectory_interception_indication
  {
    out << "trajectory_interception_indication: ";
    to_flow_style_yaml(msg.trajectory_interception_indication, out);
    out << ", ";
  }

  // member: trajectory_interception_indication_is_present
  {
    out << "trajectory_interception_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.trajectory_interception_indication_is_present, out);
    out << ", ";
  }

  // member: acceleration_change_indication
  {
    out << "acceleration_change_indication: ";
    to_flow_style_yaml(msg.acceleration_change_indication, out);
    out << ", ";
  }

  // member: acceleration_change_indication_is_present
  {
    out << "acceleration_change_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_change_indication_is_present, out);
    out << ", ";
  }

  // member: heading_change_indication
  {
    out << "heading_change_indication: ";
    to_flow_style_yaml(msg.heading_change_indication, out);
    out << ", ";
  }

  // member: heading_change_indication_is_present
  {
    out << "heading_change_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_change_indication_is_present, out);
    out << ", ";
  }

  // member: stability_change_indication
  {
    out << "stability_change_indication: ";
    to_flow_style_yaml(msg.stability_change_indication, out);
    out << ", ";
  }

  // member: stability_change_indication_is_present
  {
    out << "stability_change_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.stability_change_indication_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VruMotionPredictionContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: path_history
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_history:\n";
    to_block_style_yaml(msg.path_history, out, indentation + 2);
  }

  // member: path_history_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_history_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.path_history_is_present, out);
    out << "\n";
  }

  // member: path_prediction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_prediction:\n";
    to_block_style_yaml(msg.path_prediction, out, indentation + 2);
  }

  // member: path_prediction_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_prediction_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.path_prediction_is_present, out);
    out << "\n";
  }

  // member: safe_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "safe_distance:\n";
    to_block_style_yaml(msg.safe_distance, out, indentation + 2);
  }

  // member: safe_distance_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "safe_distance_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.safe_distance_is_present, out);
    out << "\n";
  }

  // member: trajectory_interception_indication
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "trajectory_interception_indication:\n";
    to_block_style_yaml(msg.trajectory_interception_indication, out, indentation + 2);
  }

  // member: trajectory_interception_indication_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "trajectory_interception_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.trajectory_interception_indication_is_present, out);
    out << "\n";
  }

  // member: acceleration_change_indication
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration_change_indication:\n";
    to_block_style_yaml(msg.acceleration_change_indication, out, indentation + 2);
  }

  // member: acceleration_change_indication_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration_change_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_change_indication_is_present, out);
    out << "\n";
  }

  // member: heading_change_indication
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading_change_indication:\n";
    to_block_style_yaml(msg.heading_change_indication, out, indentation + 2);
  }

  // member: heading_change_indication_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading_change_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_change_indication_is_present, out);
    out << "\n";
  }

  // member: stability_change_indication
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stability_change_indication:\n";
    to_block_style_yaml(msg.stability_change_indication, out, indentation + 2);
  }

  // member: stability_change_indication_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stability_change_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.stability_change_indication_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VruMotionPredictionContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer>()
{
  return "etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer>()
{
  return "etsi_its_vam_ts_msgs/msg/VruMotionPredictionContainer";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_vam_ts_msgs::msg::AccelerationChangeIndication>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::HeadingChangeIndication>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::PathHistory>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::PathPredicted>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::SequenceOfSafeDistanceIndication>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::SequenceOfTrajectoryInterceptionIndication>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::StabilityChangeIndication>::value> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_vam_ts_msgs::msg::AccelerationChangeIndication>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::HeadingChangeIndication>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::PathHistory>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::PathPredicted>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::SequenceOfSafeDistanceIndication>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::SequenceOfTrajectoryInterceptionIndication>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::StabilityChangeIndication>::value> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_MOTION_PREDICTION_CONTAINER__TRAITS_HPP_
