// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/SafeDistanceIndication.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__SAFE_DISTANCE_INDICATION__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__SAFE_DISTANCE_INDICATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/safe_distance_indication__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'subject_station'
#include "etsi_its_vam_ts_msgs/msg/detail/station_id__traits.hpp"
// Member 'safe_distance_indicator'
#include "etsi_its_vam_ts_msgs/msg/detail/safe_distance_indicator__traits.hpp"
// Member 'time_to_collision'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_tenth_of_second__traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SafeDistanceIndication & msg,
  std::ostream & out)
{
  out << "{";
  // member: subject_station
  {
    out << "subject_station: ";
    to_flow_style_yaml(msg.subject_station, out);
    out << ", ";
  }

  // member: subject_station_is_present
  {
    out << "subject_station_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.subject_station_is_present, out);
    out << ", ";
  }

  // member: safe_distance_indicator
  {
    out << "safe_distance_indicator: ";
    to_flow_style_yaml(msg.safe_distance_indicator, out);
    out << ", ";
  }

  // member: time_to_collision
  {
    out << "time_to_collision: ";
    to_flow_style_yaml(msg.time_to_collision, out);
    out << ", ";
  }

  // member: time_to_collision_is_present
  {
    out << "time_to_collision_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.time_to_collision_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SafeDistanceIndication & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: subject_station
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "subject_station:\n";
    to_block_style_yaml(msg.subject_station, out, indentation + 2);
  }

  // member: subject_station_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "subject_station_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.subject_station_is_present, out);
    out << "\n";
  }

  // member: safe_distance_indicator
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "safe_distance_indicator:\n";
    to_block_style_yaml(msg.safe_distance_indicator, out, indentation + 2);
  }

  // member: time_to_collision
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_to_collision:\n";
    to_block_style_yaml(msg.time_to_collision, out, indentation + 2);
  }

  // member: time_to_collision_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_to_collision_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.time_to_collision_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SafeDistanceIndication & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::SafeDistanceIndication & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::SafeDistanceIndication & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication>()
{
  return "etsi_its_vam_ts_msgs::msg::SafeDistanceIndication";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication>()
{
  return "etsi_its_vam_ts_msgs/msg/SafeDistanceIndication";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication>
  : std::integral_constant<bool, has_fixed_size<etsi_its_vam_ts_msgs::msg::DeltaTimeTenthOfSecond>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::SafeDistanceIndicator>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::StationId>::value> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication>
  : std::integral_constant<bool, has_bounded_size<etsi_its_vam_ts_msgs::msg::DeltaTimeTenthOfSecond>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::SafeDistanceIndicator>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::StationId>::value> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__SAFE_DISTANCE_INDICATION__TRAITS_HPP_
