// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruClusterOperationContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_OPERATION_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_OPERATION_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'cluster_join_info'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_join_info__struct.hpp"
// Member 'cluster_leave_info'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_leave_info__struct.hpp"
// Member 'cluster_breakup_info'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_breakup_info__struct.hpp"
// Member 'cluster_id_change_time_info'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_quarter_second__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VruClusterOperationContainer_
{
  using Type = VruClusterOperationContainer_<ContainerAllocator>;

  explicit VruClusterOperationContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_join_info(_init),
    cluster_leave_info(_init),
    cluster_breakup_info(_init),
    cluster_id_change_time_info(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cluster_join_info_is_present = false;
      this->cluster_leave_info_is_present = false;
      this->cluster_breakup_info_is_present = false;
      this->cluster_id_change_time_info_is_present = false;
    }
  }

  explicit VruClusterOperationContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_join_info(_alloc, _init),
    cluster_leave_info(_alloc, _init),
    cluster_breakup_info(_alloc, _init),
    cluster_id_change_time_info(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cluster_join_info_is_present = false;
      this->cluster_leave_info_is_present = false;
      this->cluster_breakup_info_is_present = false;
      this->cluster_id_change_time_info_is_present = false;
    }
  }

  // field types and members
  using _cluster_join_info_type =
    etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator>;
  _cluster_join_info_type cluster_join_info;
  using _cluster_join_info_is_present_type =
    bool;
  _cluster_join_info_is_present_type cluster_join_info_is_present;
  using _cluster_leave_info_type =
    etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator>;
  _cluster_leave_info_type cluster_leave_info;
  using _cluster_leave_info_is_present_type =
    bool;
  _cluster_leave_info_is_present_type cluster_leave_info_is_present;
  using _cluster_breakup_info_type =
    etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator>;
  _cluster_breakup_info_type cluster_breakup_info;
  using _cluster_breakup_info_is_present_type =
    bool;
  _cluster_breakup_info_is_present_type cluster_breakup_info_is_present;
  using _cluster_id_change_time_info_type =
    etsi_its_vam_ts_msgs::msg::DeltaTimeQuarterSecond_<ContainerAllocator>;
  _cluster_id_change_time_info_type cluster_id_change_time_info;
  using _cluster_id_change_time_info_is_present_type =
    bool;
  _cluster_id_change_time_info_is_present_type cluster_id_change_time_info_is_present;

  // setters for named parameter idiom
  Type & set__cluster_join_info(
    const etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator> & _arg)
  {
    this->cluster_join_info = _arg;
    return *this;
  }
  Type & set__cluster_join_info_is_present(
    const bool & _arg)
  {
    this->cluster_join_info_is_present = _arg;
    return *this;
  }
  Type & set__cluster_leave_info(
    const etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator> & _arg)
  {
    this->cluster_leave_info = _arg;
    return *this;
  }
  Type & set__cluster_leave_info_is_present(
    const bool & _arg)
  {
    this->cluster_leave_info_is_present = _arg;
    return *this;
  }
  Type & set__cluster_breakup_info(
    const etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator> & _arg)
  {
    this->cluster_breakup_info = _arg;
    return *this;
  }
  Type & set__cluster_breakup_info_is_present(
    const bool & _arg)
  {
    this->cluster_breakup_info_is_present = _arg;
    return *this;
  }
  Type & set__cluster_id_change_time_info(
    const etsi_its_vam_ts_msgs::msg::DeltaTimeQuarterSecond_<ContainerAllocator> & _arg)
  {
    this->cluster_id_change_time_info = _arg;
    return *this;
  }
  Type & set__cluster_id_change_time_info_is_present(
    const bool & _arg)
  {
    this->cluster_id_change_time_info_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VruClusterOperationContainer_ & other) const
  {
    if (this->cluster_join_info != other.cluster_join_info) {
      return false;
    }
    if (this->cluster_join_info_is_present != other.cluster_join_info_is_present) {
      return false;
    }
    if (this->cluster_leave_info != other.cluster_leave_info) {
      return false;
    }
    if (this->cluster_leave_info_is_present != other.cluster_leave_info_is_present) {
      return false;
    }
    if (this->cluster_breakup_info != other.cluster_breakup_info) {
      return false;
    }
    if (this->cluster_breakup_info_is_present != other.cluster_breakup_info_is_present) {
      return false;
    }
    if (this->cluster_id_change_time_info != other.cluster_id_change_time_info) {
      return false;
    }
    if (this->cluster_id_change_time_info_is_present != other.cluster_id_change_time_info_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const VruClusterOperationContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VruClusterOperationContainer_

// alias to use template instance with default allocator
using VruClusterOperationContainer =
  etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_OPERATION_CONTAINER__STRUCT_HPP_
